function df1=deriv1(y,h)
% first-order derivative of y array accurate to h^2
% derivatives at end points are from page 527 of Chapra's book 
% assumes equispaced x array with step size h

n=length(y);
df1 = (y(3:end) - y(1:end-2)); 	% central differences
d1= -y(3)+4*y(2)-3*y(1);		% first point
dn= 3*y(n)-4*y(n-1)+y(n-2);		% last point	
df1 = [d1 df1 dn]./(2*h);		% derivative at all points
